from Plugins.Plugin import PluginDescriptor
from Screens.Screen import Screen
from GlobalActions import globalActionMap

# list of mode choices to cycle through
#MODE_CHOICES_X = [720, 690, 660, 630, 600, 570, 540, 510, 480, 450, 420, 390]
#MODE_CHOICES_Y = [576, 552, 528, 504, 480, 456, 432, 408, 384, 360, 336, 312]
#MODE_CHOICES_X = [720, 600, 480]
#MODE_CHOICES_Y = [576, 480, 384]
MODE_CHOICES_X = [720, 660, 600, 540, 480, 420]
MODE_CHOICES_Y = [576, 528, 480, 432, 384, 336]

def get_mode_x():
	with open("/proc/stb/vmpeg/0/dst_width", "r") as f:
		mode_x = f.read()
	return int(mode_x, 16)

def get_mode_y():
	with open("/proc/stb/vmpeg/0/dst_height", "r") as f:
		mode_y = f.read()
	return int(mode_y, 16)
	
def set_mode_x(mode_x):
	with open("/proc/stb/vmpeg/0/dst_width", "w") as w:
		w.write("%x" % mode_x)
	with open("/proc/stb/vmpeg/0/dst_left", "w") as l:
		left = (720 - mode_x) / 2
		l.write("%x" % left)
	with open("/proc/stb/vmpeg/0/dst_apply", "w") as a:
		a.write("%x" % 0)

def set_mode_y(mode_y):
	with open("/proc/stb/vmpeg/0/dst_height", "w") as h:
		h.write("%x" % mode_y)
	with open("/proc/stb/vmpeg/0/dst_top", "w") as t:
		top = (576 - mode_y) / 2
		t.write("%x" % top)
	with open("/proc/stb/vmpeg/0/dst_apply", "w") as a:
		a.write("%x" % 0)

class ZoomInOut(Screen):
	def __init__(self, session):
		Screen.__init__(self, session)
		global globalActionMap
		globalActionMap.actions["toggle_zoominout"] = self.toggle

	def toggle(self):
		mode_x = get_mode_x()
		mode_y = get_mode_y()
		if not mode_x in MODE_CHOICES_X and not mode_y in MODE_CHOICES_Y:
			MODE_CHOICES_X.append(mode_x)
			MODE_CHOICES_Y.append(mode_y)
		modeidx_x = MODE_CHOICES_X.index(mode_x)
		modeidx_y = MODE_CHOICES_Y.index(mode_y)
		modeidx_x = (modeidx_x + 1) % len(MODE_CHOICES_X)
		modeidx_y = (modeidx_y + 1) % len(MODE_CHOICES_Y)
		set_mode_x(MODE_CHOICES_X[modeidx_x])
		set_mode_y(MODE_CHOICES_Y[modeidx_y])

zoominout = None

def zoominout_init(reason, **kwargs):
	global zoominout
	zoominout = ZoomInOut(kwargs["session"])

def Plugins(**kwargs):
	return [PluginDescriptor(where=PluginDescriptor.WHERE_SESSIONSTART, fnc=zoominout_init)]
